'Morseuhr Version 7b

' gibt alle 15 min. die Minutenzahl aus und zur vollen Stunde die Stundenzahl
' ("es ist X Uhr")

' seit Version 4b: Feintuning Sekundentakt eingebaut (beim Tageswechsel Wartezeit oder Preset
' der Sekundenvariable auf Werte > 0 )

' Ab Version 5 wird die Uhrzeit zustzlich minutengenau auf Knopfdruck ausgegeben.
'
' Die Uhrzeit wird per Museklavier voreingestellt und die Uhr dann durch einen
' Reset gestartet.
'
' Dipschalter:
' Die Stunde wird binr per 4-bit "Museklavier" an PB 2 .... PB 5 auf 8.00 Uhr bis 23.00
' vorgewhlt.
' Die Minute wird binr per 6-bit- "Museklavier" an PC 0 ... PC 5 vorgewhlt
' Die Telegrafiergeschwindigkeit wird ber ein "Museklavier" an PB1 ....PB3 in 8 Stufen
' eingestellt
' PB4: Schlagwerk ein/aus (bei "aus" wird nur noch auf Knopfdruck die Zeit ausgegeben)
' Die Tonhhe wird ber ein "Museklavier" an PB5 ....PB7 in 8 Stufen eingestellt
' Dipschalter 4 liegt in Reihe mit dem Reset-Taster; mit ihm kann man den Resettaster
' abschalten, um ein versehentliches Auslsen zu verhindern
'
' Der Tongeber (Buzzer) liegt an PB1
' Die "Plaudertaste", mit der man die Uhrzeit minutengenau abrufen kann, liegt an PB0 / PCINT0.
'
'
' Der Mega48 luft in einem speziellen Uhrenbetrieb. Er wird mit 1 MHz getaktet
' (interner RC- Oszillator), Der Quarzoszillator ist mit einem 32768Hz-Uhren-
' quarz beschaltet, der den Timer 2 asynchron taktet. Timer 2 lst ein Mal pro
' Sekunde einen Interrupt aus.

' Nach 60 Interrupts ist eine Minute um; mit Minuten wird weitergerechnet.

' Die Konfiguration des Timer2- Uhrenmodus und Erzeugung des Sekundenimpulses
' ist dem "AVR Mikrocontroller-Lehrbuch" von Roland Walter entnommen

'----------------------------------------------------------


$regfile = "m48def.dat"
$crystal = 1000000                                          ' Der AVR-Takt kommt vom RC-Oszillator


On Timer2 Ontimer2                                          ' Interrupt-Routine fr Timer2-Overflow



Dim S As Word                                               ' Sekunden
Dim T As Word                                               ' Tagesminuten 0 ..... 1440
Dim Mi As Word                                              ' Minuten- Rest zur vollen Stunde
Dim V As Word                                               ' Minuten- Rest zur vollen Viertelstunde
Dim H As Word                                               ' Stunden
Dim Zh As Word                                              ' Zehnerstelle Stunden
Dim Eh As Word                                              ' Einerstelle Stunden
Dim Zmi As Word                                             ' Zehnerstelle Minuten
Dim Emi As Word                                             ' Einerstelle Minuten

Dim I As Byte                                               ' wird in Zhlschleife verwendet
Dim N As Word                                               ' Aktueller Morsebuchstabe
Dim M As Byte                                               ' wird frs Auslesen der Morsebits verwendet
Dim L As Byte                                               ' wird fr niederwertigstes Bit von M verwendet

Dim Dit As Word                                             ' Lnge eines Punkts; daraus ergibt sich die Morsegeschwindigkeit
Dim Dah As Word                                             ' Lnge eines Strichs
Dim Wort As Word                                            ' Lnge der Pause zwischen Wrtern
Dim Tonhoehe As Word                                        ' Tonhhe

'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -



Acsr.acd = 1                                                ' Analogen Komparator ausschalten
Assr.as2 = 1                                                ' Timer2- Asynchron- Betrieb
Tccr2b = &B00000101                                         ' Vorteiler fr Timer2 auf 128 setzen
Timsk2.toie2 = 1                                            ' Timer2-Overflow-Interrupt an
Smcr = &B00000110                                           ' Powersave-Modus aktivieren

Pcicr.0 = 1                                                 ' Pin Change Interrupt Enable 0
Pcmsk0.0 = 1                                                ' Pin Change Mask PCINT0 (Interrupt durch Pin Change an PB0)

Sreg.7 = 1                                                  ' Interrupts global einschalten
Ddrb = &B00000000                                           ' alle Pins sind Eingnge
Portb = &B11111111                                          ' Pullups, damit die Eingnge nicht floaten
Ddrc = &B00000000                                           ' alle Pins sind Eingnge
Portc = &B11111111                                          ' Pullups, damit die Eingnge nicht floaten
Ddrd = &B00000000                                           ' alle Pins sind Eingnge
Portd = &B11111111                                          ' Pullups, damit die Eingnge nicht floaten

'----------------------------------------------------------




' Tonsignal an OC1A / Port B1 erzeugen; Signal wird unten durch Umschalten des DDRB im Takt der Zeichen geschaltet
'
Config Timer1 = Timer , Compare A = Toggle , Prescale = 64 , Clear Timer = 1


'
Buzzer Alias Ddrb.1
Taster Alias Pinb.0
Schlagw Alias Pind.4




Init:


' Startzeit aus den Dip- Schaltern auslesen; zunchst die Stunden

   T = Not Pinb                                             ' invertieren, weil gesetzte Dipschalter 0 statt 1 ergeben
   T = T And &B00111100                                     ' die Schalterbits filtern     - >  Tagesminute = 0,4,8 .... 28   T = T * 15                                               '  Tagesminute = 0, 60, 120 ....
   T = T * 15                                               '  Tagesminute = 0, 60, 120 ....
   T = T + 480                                              '  T = 480, 540, 600   ->  Startzeit 8,9,10 ....,22,23 Uhr

' nun die Minuten

   I = Not Pinc                                             ' invertieren, weil gesetzte Dipschalter 0 statt 1 ergeben
   I = I And &B00111111                                     ' die untersten 6 Bits ausfiltern
   T = T + I                                                ' zu den Stunden addieren


' zur Kontrolle einmalig die voreingestellte Zeit ausgeben

   Gosub Speed
   Gosub Zeitberechnung
   Gosub Zeitausgabe





Do                                                          ' Hauptschleife
       Smcr.se = 0                                          ' Sleeepmode verbieten
       Mcucr.pud = 0                                        ' Pullups aktivieren
       If T > 1439 Then                                     ' Prfen auf Tageswechsel
         T = 0
'         S = 0
        S = 2                                               ' Feinabgleich- Beispiel, falls die Uhr etwas zu langsam luft
'        Wait 2                                              ' Feinabgleich- Beispiel, falls die Uhr etwas zu schnell luft
       End If

       Gosub Zeitberechnung
       If Schlagw = 0 Then                                  ' Schlagwerk nur aktiv, wenn Pind.4 auf low liegt
          Gosub Schlagwerk
       End If

       If Taster = 0 Then                                   'Prfung, ob Zeitausgabe- Taster gedrckt
          Gosub Speed                                       ' ein Mal pro Zeitabruf wird Geschwindigkeit /Tonhhe abgefragt
          Gosub Zeitausgabe
       End If

       Mcucr.pud = 1                                        ' Pullups deakivieren; die knnen bis zu 1 mA ziehen ...
       Smcr.se = 1                                          'Sleep-Modus erlauben
       !Sleep                                               'In den Sleep-Modus gehen

Loop




Speed:

      Dit = Not Pind                                        ' invertieren
      Dit = Pind And &B00001110                             ' liegt zwischen 0 und 15, Schrittweite 2
      Shift Dit , Left , 2                                  ' liegt nun zwischen 0 und 56, Schrittweite 8
      Dit = Dit + 40                                        ' Geschwindigkeitsbereich 40 .. 96
      Dah = Dit * 3
      Wort = Dit * 8

      Tonhoehe = Not Pind
      Tonhoehe = Pind And &B11100000                        ' zwischen 0 und 224, Schrittweite 32
      Shift Tonhoehe , Right , 3                            ' nun zwischen 0 und 28, Schrittweite 4
      Tonhoehe = Tonhoehe + 8                               ' nun zwischen 8 und 40, Schrittweite 4
      Ocr1a = Tonhoehe
Return



Zeitberechnung:

       H = T / 60                                           ' Uhrzeit auf Stunden gerundet
       Mi = T Mod 60                                        ' Minuten- Rest  (zur vollen Stunde)
       Zh = H / 10                                          ' Zehnerstelle Stunden
       Eh = H Mod 10                                        ' Einerstelle Stunden
       Zmi = Mi / 10                                        ' Einerstelle Minuten
       Emi = Mi Mod 10                                      'Einerstelle Minuten
       V = T Mod 15                                         ' V = 0 bei vollen Viertelstunden
Return





Schlagwerk:

        If S < 2 Then                                       ' unterdrckt mehrfache Ausgabe
          If V = 0 Then
            If Mi = 0 Then                                  ' Sonderfall: volle Stunde
              For N = 10 To 16                              ' String "es ist "
                Gosub Morse
              Next
              If Zh > 0 Then
                 N = Zh
                 Gosub Morse
              End If
              N = Eh
              Gosub Morse
              For N = 16 To 19                              ' string " uhr"
                Gosub Morse
              Next
            Else                                            ' zur 15., 30., 45. Minute nur Minutenausgabe
              N = Zmi
                Gosub Morse
              N = Emi
                Gosub Morse
            End If
          End If
        End If
Return


Zeitausgabe:                                                ' wenn Taster gedrckt wurde

            For N = 10 To 16                                ' String "es ist "
               Gosub Morse
            Next
            If Zh > 0 Then
              N = Zh                                        ' Zehnerstelle Stunden
              Gosub Morse
            End If
            N = Eh                                          ' Einerstelle Stunden
              Gosub Morse
            For N = 16 To 20                                ' String " uhr "
              Gosub Morse
            Next
            If Zmi > 0 Then
              N = Zmi                                       ' Zehnerstelle Minuten
                Gosub Morse
            End If
            N = Emi                                         ' Einerstelle Minuten
              Gosub Morse
            For N = 20 To 23                                ' String " min"
              Gosub Morse
            Next

Return





 ' Morsezeichenerzeugung:

Morse:

     M = Lookup(n , Tdata)

     If M = 0 Then                                          ' Sonderfall: Leerzeichen;
        Waitms Wort
     Goto Sign_end
     End If

     For I = 1 To 8
       If M = 1 Then                                        ' Das Byte hat nur noch den Wert 1; Zeichenende!
          Goto Sign_end
       End If
        L = M And &B0000001                                 ' niederwertigstes Bit lesen
         Buzzer = 1                                         ' Ausgnge einschalten
       If L = 1 Then
          Waitms Dah                                        ' ist das Bit 1 -> dah
         Else
          Waitms Dit                                        ' ist das Bit 0 -> dit
       End If
         Buzzer = 0                                         ' Ausgnge abschalten
       Waitms Dit                                           ' Pause innerhalb des Morsezeichens
       Shift M , Right , 1                                  ' Bits um eine Stelle nach rechts shiften
     Next I
     Sign_end:
     Waitms Dah                                             ' Pause zwischen Morsezeichen
   Return

End


'----------------------------------------------------------
Ontimer2:                                                   'Timer2-Overflow-Interrupt-Routine

  S = S + 1
      If S > 59 Then                                        ' Minutenwechsel
'      If S > 14 Then                                          ' Testbetrieb; Minutenwechsel nach 15 sec.
        S = 0
        T = T + 1
      End If
'  Toggle Portd.0                                            ' Test,ob die Sekundenimpulse kommen
Return



'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
' Codierung der Morsezeichen. Bei einem Prozessor mit viel SRAM wrde man alle Zeichen
' in ein Array einlesen (bersetzungstabelle), den eigentlichen Bakentext in einen String packen
' und diesen String zeichenenweise abarbeiten.
'
' Da der Attiny13 nur ca. 64 Byte SRAM hat, ist nur Platz fr etwa 50 Bytes. Daher ist der Weg hier
' anders:  Der Bakentext ist ein Array mit max. 52 Elementen, in dem die auszusendenden Zeichen stehen
' allerdings in einer leicht lesbaren schreibweise.
' Die bersetzungstabelle ist mit Konstanten realisiert. Nur die wirklich bentigten
' Zeichen werden (beim kompilieren des Programmes) umgewandelt.


Const #a = &B00000110
Const #b = &B00010001
Const #c = &B00010101
Const #d = &B00001001
Const #e = &B00000010
Const #f = &B00010100
Const #g = &B00001011
Const #h = &B00010000
Const #i = &B00000100
Const #j = &B00011110
Const #k = &B00001101
Const #l = &B00010010
Const #m = &B00000111
Const #n = &B00000101
Const #o = &B00001111
Const #p = &B00010110
Const #q = &B00011011
Const #r = &B00001010
Const #s = &B00001000
Const #t = &B00000011
Const #u = &B00001100
Const #v = &B00011000
Const #w = &B00001110
Const #x = &B00011001
Const #y = &B00011101
Const #z = &B00010011
Const #ae = &B00011010
Const #oe = &B00010111
Const #ue = &B00011100
Const #0 = &B00111111
Const #1 = &B00111110
Const #2 = &B00111100
Const #3 = &B00111000
Const #4 = &B00110000
Const #5 = &B00100000
Const #6 = &B00100001
Const #7 = &B00100011
Const #8 = &B00100111
Const #9 = &B00101111

Const Leerz = 0
Const Anfuehrz = &B01010010
Const Kl_auf = &B00101101
Const Kl_zu = &B01101101
Const Plus = &B00101010
Const Komma = &B01110011
Const Minus = &B01100001
Const Punkt = &B01101010
Const Slash = &B00101001
Const Dopp_pkt = &B01000111
Const Gleich = &B00110001
Const Fragez = &B01001100
Const Ende = 255



Tdata:
Data #0 , #1 , #2 , #3 , #4 , #5 , #6 , #7 , #8 , #9
Data #e , #s , Leerz , #i , #s , #t , Leerz , #u , #h , #r , Leerz , #m , #i , #n